package webapps.ajax1.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.*;
import java.util.*;
import com.google.gson.*;
import java.io.InputStream;
import webapps.ajax1.entities.*;
import webapps.ajax1.model.*;
import java.text.*;
/**
 * Servicio JsonEj12020
 * Llamado desde pagina de ejercicios de 2020
 * Ejercicio 1
 * Input: descr  indica las tuplas a seleccionar de la tabla TEST de TEST.FDB
 * Ouput: JSON acorde con formato JTable
 * 
 * @author G. Cherencio
 * @version 1.0
 */
@WebServlet(name = "JsonEj12020", urlPatterns = {"/JsonEj12020","/JsonEj12020del"})
public class JsonEj12020 extends HttpServlet {
    private static FBCon fb0 = FBCon.getFBCon(0);

    // para customizacion de gson
    // Configure a custom GSON
    private final static GsonBuilder gsonBuilder = new GsonBuilder();
    private static Gson cgson;
    
    static {  
        gsonBuilder.registerTypeAdapter(java.util.Date.class, new DateJsonAdapter()); // tratamiento de fechas acorde con jtable.org
        gsonBuilder.registerTypeAdapter(java.sql.Date.class, new DateJsonAdapter()); // tratamiento de fechas acorde con jtable.org
        cgson = gsonBuilder.create();
    }

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("application/json");
        PrintWriter out = response.getWriter();
            
        try {
            if ( request.getRequestURI().toLowerCase().endsWith("/jsonej12020") ) {
                // url listaction
                String descr = request.getParameter("descr");
                if ( descr != null ) descr = descr.trim();
                else descr = "";
                StringBuffer bsql = new StringBuffer("SELECT id,descr as \"descripcion\",fecha FROM TEST "); 
                if ( descr.length() > 0 ) {
                    bsql.append(" WHERE descr LIKE '%" + descr + "%' ");
                } 
                bsql.append(" ORDER BY descr ASC");
                String sql = bsql.toString();
                ResultSet rs = fb0.getResultSet(sql);
                String json = cgson.toJson(ResultSetJson.toJson(rs));
                fb0.close(rs);
                //TRACE
                System.out.println("JsonEj12020 json="+json+"=");
                out.write(json); // envio respuesta json a cliente
            }
            if ( request.getRequestURI().toLowerCase().endsWith("/jsonej12020del") ) {
                // url deleteaction
                String sid = request.getParameter("id");
                if ( sid != null ) {
                    fb0.executeQuery("DELETE FROM TEST WHERE ID = " + sid);
                    out.write("{\"Result\":\"OK\"}");
                } else {
                    // esto no deberia suceder!!
                    out.write("{\"Result\":\"ERROR\",\"Message\":\"No Recibi parametro ID para delete!\"}");
                }
            }
            if ( request.getRequestURI().toLowerCase().endsWith("/jsonej12020ins") ) {
                // url createaction
                String sdescr = request.getParameter("descripcion");
                String sfecha = request.getParameter("fecha");
                ResultSet rs = fb0.getResultSet("SELECT MAX(ID) AS NID FROM TEST");
                int id = 1;
                if ( rs.next() ) {
                    if ( rs.getInt("nid") > 0 ) id = rs.getInt("nid")+1;
                }
                fb0.close(rs);
                String sfechaSQL = fb0.fechaSQL(sfecha);
                System.out.println("JsonEj12020: sid="+id+" sdescr="+sdescr+" sfecha="+sfecha+" sqlFecha="+sfechaSQL);
                fb0.executeQuery("INSERT INTO TEST(ID,DESCR,FECHA) VALUES("+id+",'"+sdescr+"','"+sfechaSQL+"')");
                SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
                java.util.Date d = new java.util.Date();
                try {
                    d = sdf.parse(sfecha);
                } catch(ParseException pe) {
                    System.err.println("JsonEj12020 Insert Error parsing Fecha "+sfecha+" con formato dd/MM/yyyy");
                }
                String sout = "{\"Result\":\"OK\",\"Record\": {\"id\":"+id+",\"descripcion\":\""+sdescr+"\",\"fecha\":\"/Date("+d.getTime()+")/\"}}";
                System.out.println("JsonEj12020 Insert out="+sout);
                out.write(sout);
            }
            
        } catch(SQLException e) {
            System.err.println("Error sql: "+e.getMessage());
            JTableData<Test> jtd = new JTableData<Test>("ERROR","SQL ERROR "+e.getMessage());
            String json = cgson.toJson(jtd);
            //TRACE
            System.out.println("JsonEj12020 SQL ERROR="+json+"=");
            out.write(json);
        } finally {
            out.close();
        }
        //TRACE
        System.out.println("JsonEj12020 FIN!!");
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
    
}

