package webapps.ajax1.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.*;
import java.sql.*;
import java.util.*;
import java.text.*;
import com.google.gson.Gson;
import webapps.ajax1.model.*;

/**
 *
 * Servlet que realiza un simple query sobre tabla mesas de examen
 * y llena una jtable de consulta
 * Hace lo mismo que JsonServlet url /JsonServletDates  pero tiene
 * control de session de usuario, es decir, si no hay un usuario
 * autenticado devuelve error
 * Utiliza base de datos isft.fdb conexion 1
 * INPUT
 *     desde  numero de milisegundos que representa fecha desde
 *     hasta  numero de milisegundos que representa fecha hasta
 * OUTPUT
 *    json compatible con jtable
 * @author grchere
 */
@WebServlet(name = "SessionDatesServlet", urlPatterns = {"/mesas"})
public class SessionDatesServlet extends HttpServlet {

    private static FBCon fb1 = FBCon.getFBCon(1);
    private static Gson gson = new Gson();

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("application/json");
        response.setContentType("text/html");

        PrintWriter out = response.getWriter();
        Map<String,String> map = new HashMap<String,String>();
        
        HttpSession session = request.getSession(false);
        if ( session != null ) {
            if ( session.getAttribute("user_name") != null ) {
                // Seguridad Ok!

                java.util.Date desde = new java.util.Date(new Long(request.getParameter("desde")));
                java.util.Date hasta = new java.util.Date(new Long(request.getParameter("hasta")));
                SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
                SimpleDateFormat sdff = new SimpleDateFormat("dd-MMM-yyyy",Locale.US);
                String sdesde = sdf.format(desde);
                String shasta = sdf.format(hasta);
                String sfdesde = sdff.format(desde);
                String sfhasta = sdff.format(hasta);
                System.out.println("Servlet SessionDatesServlet recibe desde="+sdesde+" hasta="+shasta);
                try {
                    ResultSet rs = fb1.getResultSet("SELECT IDM,FECHA,CODIGOM FROM TBL_MESAEX WHERE ESTADO = 'C' AND "+
                                                    "FECHA BETWEEN '"+sfdesde+"' AND '"+sfhasta+"'");
                    String json = gson.toJson(ResultSetJson.toJson(rs));
                    fb1.close(rs);
                    //TRACE
                    System.out.println("SessionDatesServlet json="+json+"=");
                    out.write(json);
                } catch(java.sql.SQLException e) {
                    map.put("Result","ERROR");
                    map.put("Message",e.getMessage());
                    out.write(gson.toJson(map));
                }
            } else {
                map.put("Result","ERROR");
                map.put("Message","Usuario no autenticado!, session erronea!");
                out.write(gson.toJson(map));
            }
        } else {
            map.put("Result","ERROR");
            map.put("Message","Usuario no autenticado!");
            out.write(gson.toJson(map));
        }
        out.close();
    }
    
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
    
}
